#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libwebsockets.h>
#include <stdlib.h>
#include <unistd.h>
#include <termios.h>
#include "serial.h"


#define MAX_FRAME_SIZE  1024
#define WAIT_DELAY      50
#define         SERIAL_DEVICE           "/dev/ttyUSB0"

typedef int SOCKET;
SOCKET sock;
fd_set readfs;

int sd;
int retour;



static int callback_http(
  struct libwebsocket_context *this,
  struct libwebsocket *wsi,enum libwebsocket_callback_reasons reason,
  void *user,void *in,size_t len)
{
return 0;
}

static int callback_my(
  struct libwebsocket_context * this,
  struct libwebsocket *wsi,enum libwebsocket_callback_reasons reason,
  void *user,void *in,size_t len)
{

static unsigned char taillerecue;
static unsigned char motatransmettre[1024];




switch(reason){
  case LWS_CALLBACK_ESTABLISHED:
    printf("connection established\n");
    //message=NULL;
                // Declenchement d'un prochain envoi au navigateur
    libwebsocket_callback_on_writable(this,wsi);
    break;
  case LWS_CALLBACK_RECEIVE:
  // Reception des messages de l'interface web et transmission vers panStamp
    printf("received data: %s", in);
    
    //for(i=0;i<len;i++) printf("%c",((char *)in)[i]);
    printf("\n");
	
    //Faire un Serial.write car la donnee est recu dans in. Elle sera formatée dans le javascript
    if(write(sd,in,len)!=len){ perror("main.write"); exit(-1); }
	
    break;
  case LWS_CALLBACK_SERVER_WRITEABLE:
    // Envoi des messages reçus du panStamp --> interface web
    // Il ne faut pas que la fonction read soit bloquante
   
   FD_ZERO(&readfs);
   FD_SET(sd, &readfs);
   struct timeval duree;
   duree.tv_sec = 0;
   duree.tv_usec = 10000;
   
   if((retour = select(sd + 1, &readfs, NULL, NULL, &duree)) < 0)
   {
      perror("select()");
      exit(-1);
   }
   else if (retour > 0 )
   {
	  // int in2;
	  //%02d %02x
	   //Serial.read();
	   // J'aimerais sotcker les caractères entrant dans in2, calculer la longueur len ici
	  if(read(sd,&taillerecue,sizeof(taillerecue))!=1){ perror("main.read1"); exit(-1);}
          int i; 
	  for(i=0; i<taillerecue; i++) 
	  {
	  if(read(sd, &motatransmettre[i],1)!=1){ perror("main.read2"); exit(-1);}
	  }
	  printf("taille=%d\n",taillerecue);
	  for(i=0; i<taillerecue; i++) printf("%02d ",motatransmettre[i]);
	  printf("\n");
	  

          
	  
	  unsigned char * message;
	  //message=malloc(taillerecue+LWS_SEND_BUFFER_PRE_PADDING+LWS_SEND_BUFFER_POST_PADDING);
	  message=malloc(2+LWS_SEND_BUFFER_PRE_PADDING+LWS_SEND_BUFFER_POST_PADDING);
	  if(message==NULL){ perror("callback_my.malloc"); exit(EXIT_FAILURE); }
	 // memcpy(message+LWS_SEND_BUFFER_PRE_PADDING,motatransmettre,taillerecue); 
	  if (motatransmettre[0] == 49)
           {
	  sprintf(message+LWS_SEND_BUFFER_PRE_PADDING,"%d", motatransmettre[0]);
	  libwebsocket_write(wsi,message+LWS_SEND_BUFFER_PRE_PADDING,taillerecue+1,LWS_WRITE_TEXT);
	  free(message);
	  printf("ok passage anomalie");
	   }
	else
	 {
	  sprintf(message+LWS_SEND_BUFFER_PRE_PADDING,"%d""%c""%d",motatransmettre[1],'.',motatransmettre[2]);
	  libwebsocket_write(wsi,message+LWS_SEND_BUFFER_PRE_PADDING,taillerecue+2,LWS_WRITE_TEXT);
	  free(message);
          }
	  
	
	  
   }
   
   // Declenchement d'un prochain envoi au navigateur
   libwebsocket_callback_on_writable(this,wsi);
	
      
    break;
   default:
    break;
  }
return 0;
}

static struct libwebsocket_protocols protocols[] = {
  {
    "http-only",   // name
    callback_http, // callback
    0,             // data size
    0              // maximum frame size
  },
  {"myprotocol",callback_my,0,MAX_FRAME_SIZE},
  {NULL,NULL,0,0}
  };





// Main procedure


int main(void) {
int port=9000;
struct lws_context_creation_info info;

int c=0;
sd=serialOpen(SERIAL_DEVICE,SERIAL_BOTH);

memset(&info,0,sizeof info);
info.port=port;
info.protocols=protocols;
info.gid=-1;
info.uid=-1;

serialConfig(sd,B57600);

struct libwebsocket_context *context=libwebsocket_create_context(&info);
if(context==NULL){
  fprintf(stderr, "libwebsocket init failed\n");
  return -1;
  }
printf("starting server...\n");
while(1){
  libwebsocket_service(context,WAIT_DELAY);
  }
libwebsocket_context_destroy(context);


}
