
#include "dompi.h"

// le canal RF
#define CANAL           9
// le mot de synchro
#define SYNCWORD1       0xD3
#define SYNCWORD2       0x91
// L'adresse du panstamp côté compteur
#define SOURCE          4
// L'adresse du pantsamp côté box

#define DESTINATION     2


// La conf RF
unsigned char conf[] = {CANAL, SYNCWORD1, SYNCWORD2, SOURCE};

// La liste des puissances d'émission dans l'ordre croissant
unsigned char puissances[] = {0x51, 0x8E, 0x60, 0x50, 0x8D, 0x8C, 0x8B, 0x8A, 0x8A, 0xCF, 0x89, 0x88, 0x87, 0x86, 0x85};

// le packet reçu
EMISSION rxEmission = EMISSION(DESTINATION, SOURCE);

// le paquet émis
EMISSION txEmission = EMISSION(SOURCE, DESTINATION);



boolean demande = false;

boolean commandeComplete = false;

int voie = 20;


// Modification du paramétrage RF
void setConfigRF(unsigned char* conf)
{
         // chanel compris entre 0 et 9
        if (conf[0] >= 0 && conf[0] <= 9)
        {
                panstamp.radio.setChannel(conf[0]);
        }
        panstamp.radio.setSyncWord(conf[1], conf[2]);
        // 0 correspond à l'adresse de broadcast. Elle n'est donc pas attribuab$
        if (conf[3] > 0)
        {
                panstamp.radio.setDevAddress(conf[3]);
        }
        panstamp.radio.setCCregs();
}
 
// Le traitement pour chaque paquet RF reçu
void rfPacketReceived(CCPACKET *packet)
{
        rxEmission.ajoute(*packet);
}

// Initialisation du panstamp
void setup()
{
        // Initialisation de la conf RF
        setConfigRF(conf);

        // Initialisation du port série
        Serial.begin(57600);

	// La fonction a appeler lors de la réception d'un paquet RF
        panstamp.attachInterrupt(rfPacketReceived);
	
	pinMode(voie, OUTPUT);
  pinMode(LED, OUTPUT);
  Serial.println("setup");
}






// La boucle principale
void loop()
{
        digitalWrite(LED, HIGH);
        // Traitement du paquet reçu (lorsqu'il est complet)
        if (rxEmission.complet && !rxEmission.traite)
        {

                // Passage du numéro de commande
                Serial.print("commande : ");
                Serial.write(rxEmission.commande);
		            Serial.println();

                // Passage des paramètres
                Serial.print("recoit : ");
                Serial.write(rxEmission.donnees, rxEmission.longueur);
                Serial.println();
                digitalWrite(LED, LOW);
                // Fonction de traitement des différentes commandes

                // Si recoit commande 1 de l'interface 
 		            if (rxEmission.commande == 0x33)
                {
			                  digitalWrite(voie, HIGH);
                        Serial.println("marche");
                }
		            // Si recoit commande 2 de l'interface
 		            else if (rxEmission.commande == 0x34)
		            {
 			                  digitalWrite(voie, LOW);
                        Serial.println("arret");
		            }
	
                // On est prêt à recevoir un nouveau paquet
                rxEmission.traite = true;
        }
}


