#ifndef _STRUCTURES_H
#define _STRUCTURES_H

#include "ccpacket.h"

#define EMETTEUR_MAX_LEN	512
#define EMETTEUR_ENTETE_LEN	5
#define EMETTEUR_MAX_DATA_LEN	CCPACKET_DATA_LEN - EMETTEUR_ENTETE_LEN

// le nombre de tentative d'émission d'un packet avant de retourner un echec
#define NB_TENTATIVE_EMISSION	3

/**
 * Liste des commandes
 */
enum COMMANDES
{
	COMMANDE_OBTIENT_TEMPERATURE = 0x00,
	COMMANDE_AUGUEMENTE_TEMPERATURE	= 0x01,
	COMMANDE_BAISSE_TEMPERATURE	= 0x02,
	COMMANDE_INCONNUE	= 0x0E,
	// Commande fictive qui donne le nombre de commandes existantes
	// Permet de simplifier l'écriture de traiteCommande()
	COMMANDE_LENGTH		= 0x0F
};

enum ENTETE
{
	ADR_DEST = 0,
	ADR_SRC = 1,
	COMMANDE = 2,
	NB_PAQUETS = 3,
	NUM_PAQUET = 4,
	DONNEES = 5
};

/**
 * La structure d'une emission
 */
class EMISSION
{
	private:
		CCPACKET paquet;
		unsigned char nbPaquets;
		unsigned char numPaquet;
	public:
		unsigned char adrDest;
		unsigned char adrSrc;
		unsigned char commande;
		int longueur;
		unsigned char donnees[EMETTEUR_MAX_LEN];
		bool complet;
		bool traite;
		EMISSION(unsigned char src, unsigned char dest);
		bool transmet(void);
		unsigned int ajoute(CCPACKET rxPaquet);
};

#endif // endif _STRUCTURES_H
