#!/bin/bash -x

# active le GPIO $1 si nécessaire et fixe sa direction à $2
function exportGPIO()
{
	if [ ! -L /sys/class/gpio/gpio$1 ]; then
		echo "$1" > "/sys/class/gpio/export"
	fi
	echo "$2" > /sys/class/gpio/gpio$1/direction
	if [ ! -z "$3" ]; then
		echo "$3" > /sys/class/gpio/gpio$1/value
	fi
}

# Désactive l'utilisation du GPIO $1
function unexportGPIO()
{
	if [ -L /sys/class/gpio/gpio$1 ]; then
		echo "$1" > "/sys/class/gpio/unexport"
	fi
}

# Reset du panstamp
function reset()
{
	exportGPIO 4 "out" 0
	exportGPIO 4 "out" 1
}

function upload()
{
	# activation de l'UART du raspberry
	echo -n "Activation de l'UART..."
	unexportGPIO 14
	../commun/gpio_alt -p 14 -f 0 &> /dev/null || (echo " Echec"; exit 1)
	echo " OK"

	echo -n "Upload sur le panstamp..."
	# Reset du panstamp
	reset
	# upload sur le panstamp
	avrdude -p atmega328p -P /dev/ttyAMA0 -c arduino -b 57600 -D -U flash:w:.build/avr/firmware.hex:i || ( echo " Echec";exit 2)
	echo " OK"
}

# Mise à jour du firmware et upload si aucun argument
if [ -z "$1" ]; then
	upload
# reset
elif [ "$1" == "reset" ]; then
	reset
# commande inconnue
else
	echo "commande \"$1\" inconnue"
fi
